# Generated by make gen-model. DO NOT EDIT!

from __future__ import annotations

from enum import Enum
from typing import Any, Dict, List, Optional

from pydantic import Field, constr

from starwhale.base.models.base import SwBaseModel


class UserUpdateStateRequest(SwBaseModel):
    is_enabled: bool = Field(..., alias='isEnabled')


class ResponseMessageString(SwBaseModel):
    code: str
    message: str
    data: str


class UserUpdatePasswordRequest(SwBaseModel):
    current_user_pwd: str = Field(..., alias='currentUserPwd')
    new_pwd: str = Field(..., alias='newPwd')


class UserRoleUpdateRequest(SwBaseModel):
    current_user_pwd: str = Field(..., alias='currentUserPwd')
    role_id: str = Field(..., alias='roleId')


class UpdateProjectRequest(SwBaseModel):
    project_name: Optional[str] = Field(None, alias='projectName')
    privacy: Optional[str] = None
    description: Optional[str] = None
    readme: Optional[str] = None


class ResponseMessageObject(SwBaseModel):
    code: str
    message: str
    data: Dict[str, Any]


class RuntimeTagRequest(SwBaseModel):
    force: Optional[bool] = None
    tag: str


class UpdateReportRequest(SwBaseModel):
    title: Optional[constr(min_length=0, max_length=255)] = None
    description: Optional[constr(min_length=0, max_length=255)] = None
    content: Optional[str] = None
    shared: Optional[bool] = None


class ModelUpdateRequest(SwBaseModel):
    tag: Optional[str] = None
    built_in_runtime: Optional[str] = None


class JobModifyRequest(SwBaseModel):
    comment: str


class FineTuneSpaceCreateRequest(SwBaseModel):
    name: str
    description: str


class ApplySignedUrlRequest(SwBaseModel):
    flag: Optional[str] = None
    path_prefix: str = Field(..., alias='pathPrefix')
    files: List[str] = Field(...)


class SignedUrlResponse(SwBaseModel):
    path_prefix: Optional[str] = Field(None, alias='pathPrefix')
    signed_urls: Optional[Dict[str, str]] = Field(None, alias='signedUrls')


class UserRequest(SwBaseModel):
    user_name: str = Field(..., alias='userName')
    user_pwd: str = Field(..., alias='userPwd')
    salt: Optional[str] = None


class UserCheckPasswordRequest(SwBaseModel):
    current_user_pwd: str = Field(..., alias='currentUserPwd')


class Resource(SwBaseModel):
    name: Optional[str] = None
    max: Optional[float] = None
    min: Optional[float] = None
    defaults: Optional[float] = None


class Toleration(SwBaseModel):
    key: Optional[str] = None
    operator: Optional[str] = None
    value: Optional[str] = None
    effect: Optional[str] = None
    toleration_seconds: Optional[int] = Field(None, alias='tolerationSeconds')


class UserRoleAddRequest(SwBaseModel):
    current_user_pwd: str = Field(..., alias='currentUserPwd')
    user_id: str = Field(..., alias='userId')
    role_id: str = Field(..., alias='roleId')


class CreateProjectRequest(SwBaseModel):
    project_name: str = Field(..., alias='projectName')
    privacy: str
    description: str


class Type(Enum):
    default = 'DEFAULT'
    fine_tune = 'FINE_TUNE'


class ModelSource(SwBaseModel):
    type: Optional[Type] = None
    id: Optional[int] = None


class CreateJobTemplateRequest(SwBaseModel):
    name: str
    job_url: str = Field(..., alias='jobUrl')


class ModelServingRequest(SwBaseModel):
    model_version_url: str = Field(..., alias='modelVersionUrl')
    runtime_version_url: str = Field(..., alias='runtimeVersionUrl')
    resource_pool: Optional[str] = Field(None, alias='resourcePool')
    ttl_in_seconds: Optional[int] = Field(None, alias='ttlInSeconds')
    spec: Optional[str] = None


class ModelServingVo(SwBaseModel):
    id: str
    base_uri: Optional[str] = Field(None, alias='baseUri')


class ResponseMessageModelServingVo(SwBaseModel):
    code: str
    message: str
    data: ModelServingVo


class RunEnvs(SwBaseModel):
    env_vars: Optional[Dict[str, str]] = Field(None, alias='envVars')


class BuildImageResult(SwBaseModel):
    success: Optional[bool] = None
    message: Optional[str] = None


class ResponseMessageBuildImageResult(SwBaseModel):
    code: str
    message: str
    data: BuildImageResult


class RuntimeRevertRequest(SwBaseModel):
    version_url: str = Field(..., alias='versionUrl')


class ClientRuntimeRequest(SwBaseModel):
    runtime: Optional[str] = None
    project: Optional[str] = None
    force: Optional[str] = None
    manifest: Optional[str] = None


class CreateReportRequest(SwBaseModel):
    title: constr(min_length=1, max_length=255)
    description: Optional[constr(min_length=0, max_length=255)] = None
    content: constr(min_length=1, max_length=2147483647)


class TransferReportRequest(SwBaseModel):
    target_project_url: str = Field(..., alias='targetProjectUrl')


class ModelTagRequest(RuntimeTagRequest):
    pass


class RevertModelVersionRequest(RuntimeRevertRequest):
    pass


class BizType(Enum):
    fine_tune = 'FINE_TUNE'


class Type1(Enum):
    evaluation = 'EVALUATION'
    online_eval = 'ONLINE_EVAL'
    train = 'TRAIN'
    fine_tune = 'FINE_TUNE'
    serving = 'SERVING'
    built_in = 'BUILT_IN'


class DevWay(Enum):
    vs_code = 'VS_CODE'


class JobRequest(SwBaseModel):
    model_version_id: Optional[str] = Field(None, alias='modelVersionId')
    runtime_version_id: Optional[str] = Field(None, alias='runtimeVersionId')
    dataset_version_ids: Optional[List[str]] = Field(None, alias='datasetVersionIds')
    validation_dataset_version_ids: Optional[List[str]] = Field(
        None, alias='validationDatasetVersionIds'
    )
    time_to_live_in_sec: Optional[int] = Field(None, alias='timeToLiveInSec')
    model_version_url: Optional[str] = Field(None, alias='modelVersionUrl')
    dataset_version_urls: Optional[str] = Field(None, alias='datasetVersionUrls')
    runtime_version_url: Optional[str] = Field(None, alias='runtimeVersionUrl')
    comment: Optional[str] = None
    resource_pool: str = Field(..., alias='resourcePool')
    handler: Optional[str] = None
    step_spec_over_writes: Optional[str] = Field(None, alias='stepSpecOverWrites')
    biz_type: Optional[BizType] = Field(None, alias='bizType')
    biz_id: Optional[str] = Field(None, alias='bizId')
    type: Optional[Type1] = None
    dev_mode: Optional[bool] = Field(None, alias='devMode')
    dev_password: Optional[str] = Field(None, alias='devPassword')
    dev_way: Optional[DevWay] = Field(None, alias='devWay')


class ExecRequest(SwBaseModel):
    command: List[str]


class ExecResponse(SwBaseModel):
    stdout: Optional[str] = None
    stderr: Optional[str] = None


class ResponseMessageExecResponse(SwBaseModel):
    code: str
    message: str
    data: ExecResponse


class JobModifyPinRequest(SwBaseModel):
    pinned: bool


class EventType(Enum):
    info = 'INFO'
    warning = 'WARNING'
    error = 'ERROR'


class Source(Enum):
    client = 'CLIENT'
    server = 'SERVER'
    node = 'NODE'


class EventResourceType(Enum):
    job = 'JOB'
    task = 'TASK'
    run = 'RUN'


class RelatedResource(SwBaseModel):
    event_resource_type: EventResourceType = Field(..., alias='eventResourceType')
    id: int


class ResponseMessageMapStringString(SwBaseModel):
    code: str
    message: str
    data: Dict[str, str]


class ConfigRequest(SwBaseModel):
    name: str
    content: str


class DatasetTagRequest(RuntimeTagRequest):
    pass


class DataIndexDesc(SwBaseModel):
    start: Optional[str] = None
    start_type: Optional[str] = Field(None, alias='startType')
    start_inclusive: Optional[bool] = Field(None, alias='startInclusive')
    end: Optional[str] = None
    end_type: Optional[str] = Field(None, alias='endType')
    end_inclusive: Optional[bool] = Field(None, alias='endInclusive')


class NullableResponseMessageDataIndexDesc(SwBaseModel):
    code: str
    message: str
    data: Optional[DataIndexDesc] = None


class RevertDatasetRequest(RuntimeRevertRequest):
    pass


class Desc(Enum):
    manifest = 'MANIFEST'
    src_tar = 'SRC_TAR'
    src = 'SRC'
    model = 'MODEL'
    data = 'DATA'
    unknown = 'UNKNOWN'


class Phase(Enum):
    manifest = 'MANIFEST'
    blob = 'BLOB'
    end = 'END'
    cancel = 'CANCEL'


class DatasetUploadRequest(SwBaseModel):
    upload_id: int = Field(..., alias='uploadId')
    part_name: Optional[str] = Field(None, alias='partName')
    signature: Optional[str] = None
    uri: Optional[str] = None
    desc: Optional[Desc] = None
    phase: Phase
    force: Optional[str] = None
    project: str
    swds: str


class UploadResult(SwBaseModel):
    upload_id: Optional[int] = Field(None, alias='uploadId')


class Type2(Enum):
    image = 'IMAGE'
    video = 'VIDEO'
    audio = 'AUDIO'
    json = 'JSON'
    csv = 'CSV'
    hugging_face = 'HUGGING_FACE'


class DatasetBuildRequest(SwBaseModel):
    type: Type2
    shared: Optional[bool] = None
    storage_path: str = Field(..., alias='storagePath')


class ResponseMessageMapObjectObject(SwBaseModel):
    code: str
    message: str
    data: Dict[str, Dict[str, Any]]


class FineTuneMigrationRequest(SwBaseModel):
    ids: List[str]


class MigrationResult(SwBaseModel):
    success: Optional[int] = None
    fail: Optional[int] = None


class ResponseMessageMigrationResult(SwBaseModel):
    code: str
    message: str
    data: MigrationResult


class RecordValueDesc(SwBaseModel):
    key: str
    value: Optional[Dict[str, Any]] = None


class ColumnDesc(SwBaseModel):
    column_name: Optional[str] = Field(None, alias='columnName')
    alias: Optional[str] = None


class TableDesc(SwBaseModel):
    table_name: Optional[str] = Field(None, alias='tableName')
    column_prefix: Optional[str] = Field(None, alias='columnPrefix')
    columns: Optional[List[ColumnDesc]] = None
    keep_none: Optional[bool] = Field(None, alias='keepNone')
    revision: Optional[str] = None


class ColumnHintsDesc(SwBaseModel):
    type_hints: Optional[List[str]] = Field(None, alias='typeHints')
    column_value_hints: Optional[List[str]] = Field(None, alias='columnValueHints')
    element_hints: Optional[ColumnHintsDesc] = Field(None, alias='elementHints')
    key_hints: Optional[ColumnHintsDesc] = Field(None, alias='keyHints')
    value_hints: Optional[ColumnHintsDesc] = Field(None, alias='valueHints')


class OrderByDesc(SwBaseModel):
    column_name: Optional[str] = Field(None, alias='columnName')
    descending: Optional[bool] = None


class ListTablesRequest(SwBaseModel):
    prefix: Optional[str] = None
    prefixes: Optional[List[str]] = Field(None)


class TableNameListVo(SwBaseModel):
    tables: Optional[List[str]] = None


class FlushRequest(SwBaseModel):
    pass


class InitUploadBlobRequest(SwBaseModel):
    content_md5: str = Field(..., alias='contentMd5')
    content_length: int = Field(..., alias='contentLength')


class Status(Enum):
    ok = 'OK'
    existed = 'EXISTED'


class InitUploadBlobResult(SwBaseModel):
    status: Optional[Status] = None
    blob_id: Optional[str] = Field(None, alias='blobId')
    signed_url: Optional[str] = Field(None, alias='signedUrl')


class ResponseMessageInitUploadBlobResult(SwBaseModel):
    code: str
    message: str
    data: InitUploadBlobResult


class CompleteUploadBlobResult(SwBaseModel):
    blob_id: Optional[str] = Field(None, alias='blobId')


class ResponseMessageCompleteUploadBlobResult(SwBaseModel):
    code: str
    message: str
    data: CompleteUploadBlobResult


class UserVo(SwBaseModel):
    id: str
    name: str
    created_time: int = Field(..., alias='createdTime')
    is_enabled: bool = Field(..., alias='isEnabled')
    system_role: Optional[str] = Field(None, alias='systemRole')
    project_roles: Optional[Dict[str, str]] = Field(None, alias='projectRoles')


class ResponseMessageUserVo(SwBaseModel):
    code: str
    message: str
    data: UserVo


class RoleVo(SwBaseModel):
    id: str
    name: str
    code: str
    description: Optional[str] = None


class StatisticsVo(SwBaseModel):
    model_counts: int = Field(..., alias='modelCounts')
    dataset_counts: int = Field(..., alias='datasetCounts')
    runtime_counts: int = Field(..., alias='runtimeCounts')
    member_counts: int = Field(..., alias='memberCounts')
    evaluation_counts: int = Field(..., alias='evaluationCounts')


class SystemVersionVo(SwBaseModel):
    id: Optional[str] = None
    version: Optional[str] = None


class FeaturesVo(SwBaseModel):
    disabled: List[str]


class ResponseMessageFeaturesVo(SwBaseModel):
    code: str
    message: str
    data: FeaturesVo


class DeviceVo(SwBaseModel):
    name: str


class ResponseMessageListDeviceVo(SwBaseModel):
    code: str
    message: str
    data: List[DeviceVo]


class ResponseMessageListRoleVo(SwBaseModel):
    code: str
    message: str
    data: List[RoleVo]


class ReportVo(SwBaseModel):
    id: int
    uuid: str
    title: str
    content: Optional[str] = None
    description: Optional[str] = None
    shared: Optional[bool] = None
    owner: UserVo
    created_time: int = Field(..., alias='createdTime')
    modified_time: int = Field(..., alias='modifiedTime')


class ResponseMessageReportVo(SwBaseModel):
    code: str
    message: str
    data: ReportVo


class Flag(Enum):
    added = 'added'
    updated = 'updated'
    deleted = 'deleted'
    unchanged = 'unchanged'


class Type3(Enum):
    directory = 'directory'
    file = 'file'


class FileNode(SwBaseModel):
    name: Optional[str] = None
    signature: Optional[str] = None
    flag: Optional[Flag] = None
    mime: Optional[str] = None
    type: Optional[Type3] = None
    desc: Optional[str] = None
    size: Optional[str] = None


class ListFilesResult(SwBaseModel):
    files: Optional[List[FileNode]] = None


class ResponseMessageListFilesResult(SwBaseModel):
    code: str
    message: str
    data: ListFilesResult


class TrashVo(SwBaseModel):
    id: Optional[str] = None
    name: Optional[str] = None
    type: Optional[str] = None
    trashed_time: Optional[int] = Field(None, alias='trashedTime')
    size: Optional[int] = None
    trashed_by: Optional[str] = Field(None, alias='trashedBy')
    last_updated_time: Optional[int] = Field(None, alias='lastUpdatedTime')
    retention_time: Optional[int] = Field(None, alias='retentionTime')


class JobTemplateVo(SwBaseModel):
    id: str
    name: str
    job_id: str = Field(..., alias='jobId')


class ResponseMessageListJobTemplateVo(SwBaseModel):
    code: str
    message: str
    data: List[JobTemplateVo]


class ResponseMessageJobTemplateVo(SwBaseModel):
    code: str
    message: str
    data: JobTemplateVo


class RuntimeVersionVo(SwBaseModel):
    tags: Optional[List[str]] = None
    latest: bool
    id: str
    runtime_id: str = Field(..., alias='runtimeId')
    name: str
    alias: str
    meta: Optional[str] = None
    image: str
    built_image: Optional[str] = Field(None, alias='builtImage')
    created_time: int = Field(..., alias='createdTime')
    owner: Optional[UserVo] = None
    shared: bool


class RuntimeVo(SwBaseModel):
    id: str
    name: str
    created_time: int = Field(..., alias='createdTime')
    owner: UserVo
    version: RuntimeVersionVo


class FlattenFileVo(SwBaseModel):
    name: Optional[str] = None
    size: Optional[str] = None


class RuntimeInfoVo(SwBaseModel):
    version_info: RuntimeVersionVo = Field(..., alias='versionInfo')
    id: str
    name: str
    version_id: str = Field(..., alias='versionId')
    version_name: str = Field(..., alias='versionName')
    version_alias: str = Field(..., alias='versionAlias')
    version_tag: Optional[str] = Field(None, alias='versionTag')
    version_meta: Optional[str] = Field(None, alias='versionMeta')
    manifest: str
    shared: int
    created_time: int = Field(..., alias='createdTime')
    files: Optional[List[FlattenFileVo]] = None


class PageInfoRuntimeVersionVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[RuntimeVersionVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoRuntimeVersionVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoRuntimeVersionVo


class ResponseMessageListString(SwBaseModel):
    code: str
    message: str
    data: List[str]


class ResponseMessageLong(SwBaseModel):
    code: str
    message: str
    data: int


class RuntimeVersionViewVo(SwBaseModel):
    id: str
    version_name: str = Field(..., alias='versionName')
    alias: str
    latest: bool
    shared: int
    created_time: int = Field(..., alias='createdTime')


class RuntimeViewVo(SwBaseModel):
    owner_name: str = Field(..., alias='ownerName')
    project_name: str = Field(..., alias='projectName')
    runtime_id: str = Field(..., alias='runtimeId')
    runtime_name: str = Field(..., alias='runtimeName')
    shared: bool
    versions: List[RuntimeVersionViewVo]


class PageInfoReportVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[ReportVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoReportVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoReportVo


class ComponentSpecValueType(Enum):
    float = 'FLOAT'
    int = 'INT'
    string = 'STRING'
    bool = 'BOOL'
    list = 'LIST'


class ComponentValueSpecBool(SwBaseModel):
    default_val: Optional[bool] = Field(None, alias='defaultVal')


class ComponentValueSpecFloat(SwBaseModel):
    default_val: Optional[float] = Field(None, alias='defaultVal')
    min: Optional[float] = None
    max: Optional[float] = None
    step: Optional[float] = None


class ComponentValueSpecInt(SwBaseModel):
    default_val: Optional[int] = Field(None, alias='defaultVal')
    min: Optional[int] = None
    max: Optional[int] = None


class ComponentValueSpecString(SwBaseModel):
    default_val: Optional[str] = Field(None, alias='defaultVal')


class ContainerSpec(SwBaseModel):
    image: Optional[str] = None
    cmds: Optional[List[str]] = None
    entrypoint: Optional[List[str]] = None


class Env(SwBaseModel):
    name: Optional[str] = None
    value: Optional[str] = None


class FineTune(SwBaseModel):
    require_train_datasets: Optional[bool] = None
    require_validation_datasets: Optional[bool] = None


class ParameterSignature(SwBaseModel):
    name: str
    required: Optional[bool] = None
    multiple: Optional[bool] = None


class RuntimeResource(SwBaseModel):
    type: Optional[str] = None
    request: Optional[float] = None
    limit: Optional[float] = None


class DatasetVersionViewVo(SwBaseModel):
    id: str
    version_name: str = Field(..., alias='versionName')
    alias: Optional[str] = None
    latest: bool
    shared: int
    created_time: int = Field(..., alias='createdTime')


class DatasetViewVo(SwBaseModel):
    owner_name: str = Field(..., alias='ownerName')
    project_name: str = Field(..., alias='projectName')
    dataset_id: str = Field(..., alias='datasetId')
    dataset_name: str = Field(..., alias='datasetName')
    shared: bool
    versions: List[DatasetVersionViewVo]


class ResponseMessageListDatasetViewVo(SwBaseModel):
    code: str
    message: str
    data: List[DatasetViewVo]


class ResponseMessageMapStringListFileNode(SwBaseModel):
    code: str
    message: str
    data: Dict[str, List[FileNode]]


class DatasetVersionVo(SwBaseModel):
    tags: Optional[List[str]] = None
    latest: bool
    index_table: Optional[str] = Field(None, alias='indexTable')
    id: str
    name: str
    alias: Optional[str] = None
    meta: Optional[str] = None
    created_time: int = Field(..., alias='createdTime')
    owner: Optional[UserVo] = None
    shared: bool


class DatasetVo(SwBaseModel):
    id: str
    name: str
    created_time: int = Field(..., alias='createdTime')
    owner: Optional[UserVo] = None
    version: DatasetVersionVo


class Type4(Enum):
    dev_mode = 'DEV_MODE'
    web_handler = 'WEB_HANDLER'


class ExposedLinkVo(SwBaseModel):
    type: Type4
    name: str
    link: str


class JobStatus(Enum):
    created = 'CREATED'
    ready = 'READY'
    paused = 'PAUSED'
    running = 'RUNNING'
    cancelling = 'CANCELLING'
    canceled = 'CANCELED'
    success = 'SUCCESS'
    fail = 'FAIL'
    unknown = 'UNKNOWN'


class Status1(Enum):
    pending = 'PENDING'
    running = 'RUNNING'
    finished = 'FINISHED'
    failed = 'FAILED'


class RunVo(SwBaseModel):
    id: Optional[int] = None
    task_id: Optional[int] = Field(None, alias='taskId')
    status: Optional[Status1] = None
    ip: Optional[str] = None
    start_time: Optional[int] = Field(None, alias='startTime')
    finish_time: Optional[int] = Field(None, alias='finishTime')
    failed_reason: Optional[str] = Field(None, alias='failedReason')


class TaskStatus(Enum):
    created = 'CREATED'
    ready = 'READY'
    assigning = 'ASSIGNING'
    paused = 'PAUSED'
    preparing = 'PREPARING'
    running = 'RUNNING'
    retrying = 'RETRYING'
    success = 'SUCCESS'
    cancelling = 'CANCELLING'
    canceled = 'CANCELED'
    fail = 'FAIL'
    unknown = 'UNKNOWN'


class TaskVo(SwBaseModel):
    id: str
    uuid: str
    started_time: Optional[int] = Field(None, alias='startedTime')
    finished_time: Optional[int] = Field(None, alias='finishedTime')
    task_status: TaskStatus = Field(..., alias='taskStatus')
    retry_num: Optional[int] = Field(None, alias='retryNum')
    resource_pool: str = Field(..., alias='resourcePool')
    step_name: str = Field(..., alias='stepName')
    exposed_links: Optional[List[ExposedLinkVo]] = Field(None, alias='exposedLinks')
    failed_reason: Optional[str] = Field(None, alias='failedReason')
    runs: Optional[List[RunVo]] = None


class ResponseMessageTaskVo(SwBaseModel):
    code: str
    message: str
    data: TaskVo


class ResponseMessageListRunVo(SwBaseModel):
    code: str
    message: str
    data: List[RunVo]


class EventVo(SwBaseModel):
    event_type: EventType = Field(..., alias='eventType')
    source: Source
    related_resource: RelatedResource = Field(..., alias='relatedResource')
    message: str
    data: Optional[str] = None
    timestamp: Optional[int] = None
    id: Optional[int] = None


class ResponseMessageListEventVo(SwBaseModel):
    code: str
    message: str
    data: List[EventVo]


class GraphEdge(SwBaseModel):
    from_: Optional[int] = Field(None, alias='from')
    to: Optional[int] = None
    content: Optional[str] = None


class GraphNode(SwBaseModel):
    id: Optional[int] = None
    type: Optional[str] = None
    content: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    entity_id: Optional[int] = Field(None, alias='entityId')


class ConfigVo(SwBaseModel):
    name: Optional[str] = None
    content: Optional[str] = None
    create_time: Optional[int] = Field(None, alias='createTime')


class ResponseMessageConfigVo(SwBaseModel):
    code: str
    message: str
    data: ConfigVo


class PageInfoDatasetVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[DatasetVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoDatasetVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoDatasetVo


class DatasetInfoVo(SwBaseModel):
    index_table: Optional[str] = Field(None, alias='indexTable')
    version_info: Optional[DatasetVersionVo] = Field(None, alias='versionInfo')
    id: str
    name: str
    version_id: str = Field(..., alias='versionId')
    version_name: str = Field(..., alias='versionName')
    version_alias: Optional[str] = Field(None, alias='versionAlias')
    version_tag: Optional[str] = Field(None, alias='versionTag')
    shared: int
    created_time: int = Field(..., alias='createdTime')
    files: Optional[List[FlattenFileVo]] = None
    version_meta: str = Field(..., alias='versionMeta')


class ResponseMessageDatasetInfoVo(SwBaseModel):
    code: str
    message: str
    data: DatasetInfoVo


class PageInfoDatasetVersionVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[DatasetVersionVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoDatasetVersionVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoDatasetVersionVo


class BuildRecordVo(SwBaseModel):
    id: str
    project_id: str = Field(..., alias='projectId')
    task_id: str = Field(..., alias='taskId')
    dataset_name: str = Field(..., alias='datasetName')
    status: TaskStatus
    type: Type2
    create_time: int = Field(..., alias='createTime')


class PageInfoBuildRecordVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[BuildRecordVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoBuildRecordVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoBuildRecordVo


class ModelServingStatusVo(SwBaseModel):
    progress: Optional[int] = None
    events: Optional[str] = None


class ResponseMessageModelServingStatusVo(SwBaseModel):
    code: str
    message: str
    data: ModelServingStatusVo


class FineTuneSpaceVo(SwBaseModel):
    id: int
    name: str
    description: Optional[str] = None
    created_time: int = Field(..., alias='createdTime')
    owner: UserVo


class PageInfoFineTuneSpaceVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[FineTuneSpaceVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoFineTuneSpaceVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoFineTuneSpaceVo


class ResponseMessageFineTuneSpaceVo(SwBaseModel):
    code: str
    message: str
    data: FineTuneSpaceVo


class PanelPluginVo(SwBaseModel):
    id: str
    name: str
    version: str


class RuntimeSuggestionVo(SwBaseModel):
    runtimes: Optional[List[RuntimeVersionVo]] = None


class UserRoleDeleteRequest(UserCheckPasswordRequest):
    pass


class FileDeleteRequest(SwBaseModel):
    path_prefix: str = Field(..., alias='pathPrefix')
    files: List[str] = Field(...)


class ResponseMessageSignedUrlResponse(SwBaseModel):
    code: str
    message: str
    data: SignedUrlResponse


class ResourcePool(SwBaseModel):
    name: Optional[str] = None
    node_selector: Optional[Dict[str, str]] = Field(None, alias='nodeSelector')
    resources: Optional[List[Resource]] = None
    tolerations: Optional[List[Toleration]] = None
    metadata: Optional[Dict[str, str]] = None
    is_private: Optional[bool] = Field(None, alias='isPrivate')
    visible_user_ids: Optional[List[int]] = Field(None, alias='visibleUserIds')


class CreateModelVersionRequest(SwBaseModel):
    meta_blob_id: str = Field(..., alias='metaBlobId')
    built_in_runtime: Optional[str] = Field(None, alias='builtInRuntime')
    model_source: Optional[ModelSource] = Field(None, alias='modelSource')
    force: Optional[bool] = None


class EventRequest(SwBaseModel):
    event_type: EventType = Field(..., alias='eventType')
    source: Source
    related_resource: RelatedResource = Field(..., alias='relatedResource')
    message: str
    data: Optional[str] = None
    timestamp: Optional[int] = None


class DataConsumptionRequest(SwBaseModel):
    session_id: Optional[str] = Field(None, alias='sessionId')
    consumer_id: Optional[str] = Field(None, alias='consumerId')
    batch_size: Optional[int] = Field(None, alias='batchSize')
    start: Optional[str] = None
    start_type: Optional[str] = Field(None, alias='startType')
    start_inclusive: Optional[bool] = Field(None, alias='startInclusive')
    end: Optional[str] = None
    end_type: Optional[str] = Field(None, alias='endType')
    end_inclusive: Optional[bool] = Field(None, alias='endInclusive')
    processed_data: Optional[List[DataIndexDesc]] = Field(None, alias='processedData')
    serial: Optional[bool] = None


class ResponseMessageUploadResult(SwBaseModel):
    code: str
    message: str
    data: UploadResult


class RecordDesc(SwBaseModel):
    values: List[RecordValueDesc]


class ScanTableRequest(SwBaseModel):
    tables: Optional[List[TableDesc]] = None
    start: Optional[str] = None
    start_type: Optional[str] = Field(None, alias='startType')
    start_inclusive: Optional[bool] = Field(None, alias='startInclusive')
    end: Optional[str] = None
    end_type: Optional[str] = Field(None, alias='endType')
    end_inclusive: Optional[bool] = Field(None, alias='endInclusive')
    limit: Optional[int] = None
    keep_none: Optional[bool] = Field(None, alias='keepNone')
    raw_result: Optional[bool] = Field(None, alias='rawResult')
    encode_with_type: Optional[bool] = Field(None, alias='encodeWithType')
    ignore_non_existing_table: Optional[bool] = Field(
        None, alias='ignoreNonExistingTable'
    )


class ResponseMessageTableNameListVo(SwBaseModel):
    code: str
    message: str
    data: TableNameListVo


class PageInfoUserVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[UserVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoUserVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoUserVo


class ProjectVo(SwBaseModel):
    id: str
    name: str
    description: Optional[str] = None
    privacy: str
    created_time: int = Field(..., alias='createdTime')
    owner: UserVo
    statistics: Optional[StatisticsVo] = None


class ResponseMessageSystemVersionVo(SwBaseModel):
    code: str
    message: str
    data: SystemVersionVo


class ResponseMessageListResourcePool(SwBaseModel):
    code: str
    message: str
    data: List[ResourcePool]


class PageInfoProjectVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[ProjectVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoProjectVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoProjectVo


class ResponseMessageProjectVo(SwBaseModel):
    code: str
    message: str
    data: ProjectVo


class PageInfoTrashVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[TrashVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoTrashVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoTrashVo


class PageInfoRuntimeVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[RuntimeVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoRuntimeVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoRuntimeVo


class ResponseMessageRuntimeInfoVo(SwBaseModel):
    code: str
    message: str
    data: RuntimeInfoVo


class ResponseMessageListRuntimeViewVo(SwBaseModel):
    code: str
    message: str
    data: List[RuntimeViewVo]


class ComponentSpec(SwBaseModel):
    component_value_spec_int: Optional[ComponentValueSpecInt] = Field(
        None, alias='componentValueSpecInt'
    )
    component_value_spec_float: Optional[ComponentValueSpecFloat] = Field(
        None, alias='componentValueSpecFloat'
    )
    component_value_spec_string: Optional[ComponentValueSpecString] = Field(
        None, alias='componentValueSpecString'
    )
    component_value_spec_bool: Optional[ComponentValueSpecBool] = Field(
        None, alias='componentValueSpecBool'
    )
    name: str
    component_spec_value_type: ComponentSpecValueType


class PageInfoTaskVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[TaskVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoTaskVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoTaskVo


class Graph(SwBaseModel):
    id: Optional[int] = None
    grouping_nodes: Optional[Dict[str, List[GraphNode]]] = Field(
        None, alias='groupingNodes'
    )
    edges: Optional[List[GraphEdge]] = None


class ResponseMessageGraph(SwBaseModel):
    code: str
    message: str
    data: Graph


class PageInfoPanelPluginVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[PanelPluginVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoPanelPluginVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoPanelPluginVo


class ResponseMessageRuntimeSuggestionVo(SwBaseModel):
    code: str
    message: str
    data: RuntimeSuggestionVo


class ProjectMemberVo(SwBaseModel):
    id: str
    user: UserVo
    project: ProjectVo
    role: RoleVo


class ResponseMessageListProjectMemberVo(SwBaseModel):
    code: str
    message: str
    data: List[ProjectMemberVo]


class ApiSpec(SwBaseModel):
    uri: str
    inference_type: Optional[str] = None
    components: Optional[List[ComponentSpec]] = None


class ServiceSpec(SwBaseModel):
    version: Optional[str] = None
    title: Optional[str] = None
    description: Optional[str] = None
    apis: Optional[List[ApiSpec]] = None


class StepSpec(SwBaseModel):
    name: str
    concurrency: Optional[int] = None
    replicas: int
    backoff_limit: Optional[int] = Field(None, alias='backoffLimit')
    needs: Optional[List[str]] = None
    resources: Optional[List[RuntimeResource]] = None
    env: Optional[List[Env]] = None
    expose: Optional[int] = None
    virtual: Optional[bool] = None
    job_name: Optional[str] = None
    show_name: str
    require_dataset: Optional[bool] = None
    fine_tune: Optional[FineTune] = None
    container_spec: Optional[ContainerSpec] = None
    ext_cmd_args: Optional[str] = None
    parameters_sig: Optional[List[ParameterSignature]] = None
    service_spec: Optional[ServiceSpec] = None


class ModelVersionVo(SwBaseModel):
    latest: bool
    tags: Optional[List[str]] = None
    step_specs: List[StepSpec] = Field(..., alias='stepSpecs')
    id: str
    name: str
    alias: str
    size: Optional[int] = None
    created_time: int = Field(..., alias='createdTime')
    owner: Optional[UserVo] = None
    shared: bool
    built_in_runtime: Optional[str] = Field(None, alias='builtInRuntime')
    draft: bool


class ModelVo(SwBaseModel):
    id: str
    name: str
    created_time: int = Field(..., alias='createdTime')
    owner: UserVo
    version: ModelVersionVo


class PageInfoModelVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[ModelVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoModelVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoModelVo


class ModelInfoVo(SwBaseModel):
    version_info: ModelVersionVo = Field(..., alias='versionInfo')
    id: str
    name: str
    version_alias: str = Field(..., alias='versionAlias')
    version_id: str = Field(..., alias='versionId')
    version_name: str = Field(..., alias='versionName')
    version_tag: Optional[str] = Field(None, alias='versionTag')
    created_time: int = Field(..., alias='createdTime')
    shared: int


class ResponseMessageModelInfoVo(SwBaseModel):
    code: str
    message: str
    data: ModelInfoVo


class PageInfoModelVersionVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[ModelVersionVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoModelVersionVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoModelVersionVo


class JobVo(SwBaseModel):
    exposed_links: List[ExposedLinkVo] = Field(..., alias='exposedLinks')
    id: str
    uuid: str
    model_name: str = Field(..., alias='modelName')
    model_version: str = Field(..., alias='modelVersion')
    model: ModelVo
    job_name: Optional[str] = Field(None, alias='jobName')
    job_type: Optional[Type1] = Field(None, alias='jobType')
    datasets: Optional[List[str]] = None
    dataset_list: Optional[List[DatasetVo]] = Field(None, alias='datasetList')
    runtime: RuntimeVo
    is_builtin_runtime: Optional[bool] = Field(None, alias='isBuiltinRuntime')
    device: Optional[str] = None
    device_amount: Optional[int] = Field(None, alias='deviceAmount')
    owner: UserVo
    created_time: int = Field(..., alias='createdTime')
    stop_time: Optional[int] = Field(None, alias='stopTime')
    job_status: JobStatus = Field(..., alias='jobStatus')
    comment: Optional[str] = None
    step_spec: Optional[str] = Field(None, alias='stepSpec')
    resource_pool: str = Field(..., alias='resourcePool')
    duration: Optional[int] = None
    pinned_time: Optional[int] = Field(None, alias='pinnedTime')


class PageInfoJobVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[JobVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoJobVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoJobVo


class ResponseMessageJobVo(SwBaseModel):
    code: str
    message: str
    data: JobVo


class ResponseMessageListJobVo(SwBaseModel):
    code: str
    message: str
    data: List[JobVo]


class FineTuneVo(SwBaseModel):
    id: int
    job: JobVo
    train_datasets: List[DatasetVo] = Field(..., alias='trainDatasets')
    validation_datasets: Optional[List[DatasetVo]] = Field(
        None, alias='validationDatasets'
    )
    target_model: ModelVo = Field(..., alias='targetModel')


class PageInfoFineTuneVo(SwBaseModel):
    total: Optional[int] = None
    list: Optional[List[FineTuneVo]] = None
    page_num: Optional[int] = Field(None, alias='pageNum')
    page_size: Optional[int] = Field(None, alias='pageSize')
    size: Optional[int] = None
    start_row: Optional[int] = Field(None, alias='startRow')
    end_row: Optional[int] = Field(None, alias='endRow')
    pages: Optional[int] = None
    pre_page: Optional[int] = Field(None, alias='prePage')
    next_page: Optional[int] = Field(None, alias='nextPage')
    is_first_page: Optional[bool] = Field(None, alias='isFirstPage')
    is_last_page: Optional[bool] = Field(None, alias='isLastPage')
    has_previous_page: Optional[bool] = Field(None, alias='hasPreviousPage')
    has_next_page: Optional[bool] = Field(None, alias='hasNextPage')
    navigate_pages: Optional[int] = Field(None, alias='navigatePages')
    navigatepage_nums: Optional[List[int]] = Field(None, alias='navigatepageNums')
    navigate_first_page: Optional[int] = Field(None, alias='navigateFirstPage')
    navigate_last_page: Optional[int] = Field(None, alias='navigateLastPage')


class ResponseMessagePageInfoFineTuneVo(SwBaseModel):
    code: str
    message: str
    data: PageInfoFineTuneVo


class ResponseMessageFineTuneVo(SwBaseModel):
    code: str
    message: str
    data: FineTuneVo


class ModelVersionViewVo(SwBaseModel):
    id: str
    version_name: str = Field(..., alias='versionName')
    alias: str
    latest: bool
    tags: Optional[List[str]] = None
    shared: int
    draft: Optional[bool] = None
    step_specs: List[StepSpec] = Field(..., alias='stepSpecs')
    built_in_runtime: Optional[str] = Field(None, alias='builtInRuntime')
    created_time: int = Field(..., alias='createdTime')


class ModelViewVo(SwBaseModel):
    owner_name: str = Field(..., alias='ownerName')
    project_name: str = Field(..., alias='projectName')
    model_id: str = Field(..., alias='modelId')
    model_name: str = Field(..., alias='modelName')
    shared: bool
    versions: List[ModelVersionViewVo]


class ResponseMessageListModelViewVo(SwBaseModel):
    code: str
    message: str
    data: List[ModelViewVo]


class ColumnSchemaDesc(SwBaseModel):
    name: Optional[str] = None
    index: Optional[int] = None
    type: Optional[str] = None
    python_type: Optional[str] = Field(None, alias='pythonType')
    element_type: Optional[ColumnSchemaDesc] = Field(None, alias='elementType')
    key_type: Optional[ColumnSchemaDesc] = Field(None, alias='keyType')
    value_type: Optional[ColumnSchemaDesc] = Field(None, alias='valueType')
    attributes: Optional[List[ColumnSchemaDesc]] = None
    sparse_key_value_pair_schema: Optional[Dict[str, KeyValuePairSchema]] = Field(
        None, alias='sparseKeyValuePairSchema'
    )


class KeyValuePairSchema(SwBaseModel):
    key_type: Optional[ColumnSchemaDesc] = Field(None, alias='keyType')
    value_type: Optional[ColumnSchemaDesc] = Field(None, alias='valueType')


class TableSchemaDesc(SwBaseModel):
    key_column: Optional[str] = Field(None, alias='keyColumn')
    column_schema_list: Optional[List[ColumnSchemaDesc]] = Field(
        None, alias='columnSchemaList'
    )


class UpdateTableRequest(SwBaseModel):
    table_name: Optional[str] = Field(None, alias='tableName')
    table_schema_desc: Optional[TableSchemaDesc] = Field(None, alias='tableSchemaDesc')
    records: Optional[List[RecordDesc]] = None


class RecordListVo(SwBaseModel):
    column_types: Optional[List[ColumnSchemaDesc]] = Field(None, alias='columnTypes')
    column_hints: Optional[Dict[str, ColumnHintsDesc]] = Field(
        None, alias='columnHints'
    )
    records: Optional[List[Dict[str, Dict[str, Any]]]] = None
    last_key: Optional[str] = Field(None, alias='lastKey')


class ResponseMessageRecordListVo(SwBaseModel):
    code: str
    message: str
    data: RecordListVo


class QueryTableRequest(SwBaseModel):
    table_name: Optional[str] = Field(None, alias='tableName')
    columns: Optional[List[ColumnDesc]] = None
    order_by: Optional[List[OrderByDesc]] = Field(None, alias='orderBy')
    descending: Optional[bool] = None
    filter: Optional[TableQueryFilterDesc] = None
    start: Optional[int] = None
    limit: Optional[int] = None
    keep_none: Optional[bool] = Field(None, alias='keepNone')
    raw_result: Optional[bool] = Field(None, alias='rawResult')
    encode_with_type: Optional[bool] = Field(None, alias='encodeWithType')
    ignore_non_existing_table: Optional[bool] = Field(
        None, alias='ignoreNonExistingTable'
    )
    revision: Optional[str] = None


class TableQueryFilterDesc(SwBaseModel):
    operator: str
    operands: Optional[List[TableQueryOperandDesc]] = None


class TableQueryOperandDesc(SwBaseModel):
    filter: Optional[TableQueryFilterDesc] = None
    column_name: Optional[str] = Field(None, alias='columnName')
    bool_value: Optional[bool] = Field(None, alias='boolValue')
    int_value: Optional[int] = Field(None, alias='intValue')
    float_value: Optional[float] = Field(None, alias='floatValue')
    string_value: Optional[str] = Field(None, alias='stringValue')
    bytes_value: Optional[str] = Field(None, alias='bytesValue')


ColumnHintsDesc.update_forward_refs()
ColumnSchemaDesc.update_forward_refs()
QueryTableRequest.update_forward_refs()
TableQueryFilterDesc.update_forward_refs()
